#include "IIC.h"

u8 ack;

void IIC_INIT()
{
	I2C_S1 = 0;			// 
	I2C_S0 = 1;
	I2CCFG = 0xE0;		// ٶȺʹIIC
	I2CMSST = 0;		// ״̬
}

void IIC_DELAY()		//@11.0592MHz
{
	while( !(I2CMSST & 0x40) );
	I2CMSST &= (~0x40);
}

void IIC_START(void)		// ź
{
	I2CMSCR = 0x01;			// ʼ
	IIC_DELAY();			// ȴ
}

void IIC_STOP(void)			// ֹͣź
{
	I2CMSCR = 0x06;			// 
	IIC_DELAY();			// ȴ
}

void IIC_SENDACK(void)
{
	I2CMSST = 0x00;			// ACK
	I2CMSCR = 0x05;			// 
	IIC_DELAY();			// ȴ
}

void IIC_SENDNACK(void)
{
	I2CMSST = 0x01;			// NACK
	I2CMSCR = 0x05;			// 
	IIC_DELAY();			// ȴ
}


void IIC_WAITACK(void)
{
	I2CMSCR = 0x03;			// ACK
	IIC_DELAY();			// ȴ
}


void IIC_SENDBYTE(u8 dat)
{
	I2CTXD = dat;
	I2CMSCR = 0x02;			// 
	IIC_DELAY();			// ȴ
}

u8 IIC_READBYTE(void)
{
	I2CMSCR = 0x04;			// 
	IIC_DELAY();			// ȴ
	return I2CRXD;
}

// -------------------------ܺд------------------------------
void IIC_Write_NByte(u8 slave, u8 addr, u8 *p, u8 number)
{
	IIC_START();
	IIC_SENDBYTE(slave);
	IIC_WAITACK();

	IIC_SENDBYTE(addr);
	IIC_WAITACK();

	do
	{
		IIC_SENDBYTE(*p);
		p++;
		IIC_WAITACK();
		if(ack)
			break;
	}
	while(--number);

	IIC_STOP();
}


void IIC_Read_NByte(u8 slave, u8 addr, u8 *p, u8 number)
{
	IIC_START();
	IIC_SENDBYTE(slave);
	IIC_WAITACK();

	IIC_SENDBYTE(addr);
	IIC_WAITACK();

	IIC_START();
	IIC_SENDBYTE(slave|0x01);
	IIC_WAITACK();

	do
	{
		*p = IIC_READBYTE();
		p++;
		if(number!=1)
			IIC_SENDACK();
	}
	while(--number);
	IIC_SENDNACK();

	IIC_STOP();
}

